WSD_Game_Store/urls.py
from django.contrib import admin
from django.contrib.auth.views import LoginView, LogoutView
from django.urls import path
from . import views
from django.views.generic.base import TemplateView
from django.views.generic import ListView
from .views import GameList, BoughtGameDetail, GameCreate, GameUpdate, GameDelete, BoughtGameList, DeveloperGameList

urlpatterns = [
    path('gamer-signup/', views.gamer_signup, name='gamer-signup'),
    path('developer-signup/', views.developer_signup, name='developer-signup'),
    path('login/', LoginView.as_view(template_name='login.html'), name="login"),
    path('logout/', LogoutView.as_view(template_name='index.html'), name="logout"),

    path('admin/', admin.site.urls),
    path('', views.home, name='home'),

    path('games/', GameList.as_view(), name='games'),
    path('games/<int:pk>/buy/', views.buy, name='game-buy'),
    path('buy/finished', views.buy_finished),

    path('bought-games/', BoughtGameList.as_view(), name='bought-games'),
    path('bought-games/<int:pk>', BoughtGameDetail.as_view(), name='game-detail'),
    path('bought-games/<int:pk>/score', views.score, name='score'),

    path('developed-games/', DeveloperGameList.as_view(), name='developed-games'),
    path('developed-games/create/', GameCreate.as_view(), name='game-create'),
    path('developed-games/<int:pk>/', GameUpdate.as_view(), name='game-update'),
    path('developed-games/<int:pk>/delete/', GameDelete.as_view(), name='game-delete'),
]

WSD_Game_Store/models.py
from django.db import models
from django.contrib.auth.models import User
from django.forms import ModelForm

class Game(models.Model):
    title = models.CharField(max_length=30)
    description = models.TextField(max_length=500, blank=True)
    url = models.URLField(max_length=200)
    price = models.DecimalField(max_digits=5, decimal_places=2)
    developer = models.ForeignKey(User, on_delete=models.CASCADE)

    def __repr__(self):
        return self.title + " " + str(self.id)

    def __str__(self):
        return self.__repr__()

class GameForm(ModelForm):
    class Meta:
        model = Game
        exclude = ['developer']

class BoughtGame(models.Model):
    game = models.ForeignKey(Game, on_delete=models.CASCADE)
    buyer = models.ForeignKey(User, on_delete=models.CASCADE)

    class Meta:
        unique_together = ('buyer', 'game')

    def __repr__(self):
        return str(self.game) + ": " + str(self.buyer)

    def __str__(self):
        return self.__repr__()

# Meant to be used for auditing
# This means that cascade should be protect instead and deletion handled differently
# But as this is school project I take the easy way.
class Payment(models.Model):
    ERROR='E'
    SUCCESS='S'
    CANCEL='C'
    STATUS = [
        (ERROR, 'Error'),
        (SUCCESS, 'Success'),
        (CANCEL, 'Cancel'),
    ]
    game = models.ForeignKey(Game, on_delete=models.CASCADE)
    buyer = models.ForeignKey(User, on_delete=models.CASCADE)
    created = models.DateTimeField(auto_now_add=True)
    status = models.CharField(max_length=1,choices=STATUS,null=True,default=None)
    finished = models.DateTimeField(null=True)
    reference = models.CharField(max_length=64, null=True)

class Gamer(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)

    class Meta:
        permissions = [('buy_game', 'Can buy games')]

class Developer(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)

class Score(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    game = models.ForeignKey(Game, on_delete=models.CASCADE)
    score = models.IntegerField()

    class Meta:
        ordering = ['-score']

WSD_Game_Store/views.py
from django.views.generic import ListView, DetailView
from django.views.generic.edit import CreateView, DeleteView, UpdateView
from django.contrib.auth.mixins import LoginRequiredMixin, PermissionRequiredMixin
from .models import Game, GameForm, BoughtGame, Payment, Gamer, Developer, Score
from django.shortcuts import render, redirect, get_object_or_404
from django.contrib.auth.decorators import login_required, permission_required
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth import login, authenticate
from django.contrib.auth.models import Permission
from hashlib import md5
from datetime import datetime
from django.http import HttpResponse
import json

seller_id = "5ZqhIU1pa2tvX1dTRA=="
payment_secret = "V_B-jadVRIAp3glwSTSRrWXX4kwA"

@login_required
def home(request):
    if hasattr(request, 'request'):
        return redirect(request.request.GET.get('next'))
    return render(request, 'index.html')

def gamer_signup(request):
    if request.method == 'POST':
        form = UserCreationForm(request.POST)
        user = __create_user(form)
        if user:
            user.user_permissions.set(__gamer_permissions())
            user.save()
            Gamer.objects.create(user=user)
            login(request, user)
            return redirect('games')
    else:
        form = UserCreationForm()
    return render(request, 'signup.html', {'form': form})

def developer_signup(request):
    if request.method == 'POST':
        form = UserCreationForm(request.POST)
        user = __create_user(form)
        if user:
            user.user_permissions.set(__developer_permissions())
            user.save()
            Developer.objects.create(user=user)
            login(request, user)
            return redirect('developed-games')
    else:
        form = UserCreationForm()
    return render(request, 'signup.html', {'form': form})

def __create_user(form):
    if form.is_valid():
        form.save()
        username = form.cleaned_data.get('username')
        raw_password = form.cleaned_data.get('password1')
        user = authenticate(username=username, password=raw_password)
        return user

def __developer_permissions():
    add_game = Permission.objects.get(codename='add_game')
    change_game = Permission.objects.get(codename='change_game')
    delete_game = Permission.objects.get(codename='delete_game')
    return [add_game, change_game, delete_game]

def __gamer_permissions():
    view_game = Permission.objects.get(codename='view_game')
    buy_game = Permission.objects.get(codename='buy_game')
    return [view_game, buy_game]

class GameList(LoginRequiredMixin, ListView):
    login_url = '/login/'
    model = Game

    def get_context_data(self, **kwargs):
        user = self.request.user
        context = super().get_context_data(**kwargs)
        bought_games = list(map(lambda x: x.game, BoughtGame.objects.filter(buyer=user)))
        context['bought_games'] = bought_games
        return context

class BoughtGameList(LoginRequiredMixin, ListView):
    login_url = '/login/'

    def get_queryset(self):
        return BoughtGame.objects.filter(buyer=self.request.user)

class BoughtGameDetail(LoginRequiredMixin, DetailView):
    template_name = 'WSD_Game_Store/boughtgame_detail.html'

    def get_queryset(self):
        user = self.request.user
        return BoughtGame.objects.filter(buyer=user)

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['scores'] = Score.objects.filter(game=self.object.game)
        return context

class DeveloperGameList(LoginRequiredMixin, ListView):
    login_url = '/login/'
    template_name = 'WSD_Game_Store/developergame_list.html'

    def get_queryset(self):
        user = self.request.user
        games = Game.objects.filter(developer=user)
        for game in games:
            times_bought = BoughtGame.objects.filter(game=game).count()
            game.times_bought = times_bought
        return games

class GameCreate(LoginRequiredMixin, PermissionRequiredMixin, CreateView):
    permission_required = 'WSD_Game_Store.add_game'
    login_url = '/login/'
    model = Game
    form_class = GameForm
    success_url = '/developed-games/'

    def form_valid(self, form):
        form.instance.developer = self.request.user
        return super().form_valid(form)

class GameUpdate(LoginRequiredMixin, PermissionRequiredMixin, UpdateView):
    permission_required = 'WSD_Game_Store.change_game'
    login_url = '/login/'
    model = Game
    form_class = GameForm
    success_url = '/developed-games/'

    def user_passes_test(self, request):
        if request.user.is_authenticated:
            self.object = self.get_object()
            return self.object.developer == request.user
        return False

    def dispatch(self, request, *args, **kwargs):
        if not self.user_passes_test(request):
            raise Exception("User " + str(request.user.id)+ " does not own game " + str(self.object.id))
        return super(GameUpdate, self).dispatch(request, *args, **kwargs)

class GameDelete(LoginRequiredMixin, PermissionRequiredMixin, DeleteView):
    permission_required = 'WSD_Game_Store.delete_game'
    login_url = '/login/'
    model = Game
    success_url = '/developed-games/'

    def user_passes_test(self, request):
        if request.user.is_authenticated:
            self.object = self.get_object()
            return self.object.developer == request.user
        return False

    def dispatch(self, request, *args, **kwargs):
        if not self.user_passes_test(request):
            raise Exception("User " + str(request.user.id)+ " does not own game " + str(self.object.id))
        return super(GameDelete, self).dispatch(request, *args, **kwargs)

@login_required
@permission_required('WSD_Game_Store.buy_game', raise_exception=True)
def buy(request, pk):
    user = request.user
    game = get_object_or_404(Game, id=pk)
    if BoughtGame.objects.filter(buyer=user, game=game).exists():
        raise Exception("Game already bought, cannot continue")
    payment = Payment.objects.create(game=game, buyer=user)
    amount = game.price
    payment_id = str(payment.id)

    checksumstr = f"pid={payment_id:s}&sid={seller_id:s}&amount={amount:.2f}&token={payment_secret:s}"
    checksum = md5(checksumstr.encode('utf-8')).hexdigest()

    host = request.get_host()
    params = "?pid=" + payment_id
    params += "&sid=" + seller_id
    params += "&amount=" + str(amount)
    params += f"&error_url=http://{host}/buy/finished"
    params += f"&success_url=http://{host}/buy/finished"
    params += f"&cancel_url=http://{host}/buy/finished"
    params += "&checksum=" + checksum
    return redirect('https://tilkkutakki.cs.aalto.fi/payments/pay'+params)

@login_required
def buy_finished(request):
    user = request.user
    payment_id = request.GET.get('pid')
    payment = Payment.objects.get(pk=payment_id)
    reference = request.GET.get('ref')
    status_string = request.GET.get('result')
    status = __string_to_status(status_string)

    checksumstr = f"pid={payment_id:s}&ref={reference:s}&result={status_string:s}&token={payment_secret:s}"
    checksum = md5(checksumstr.encode('utf-8')).hexdigest()
    if checksum != request.GET.get('checksum'):
        __finish_payment(payment, Payment.ERROR, reference)
        raise Exception("Wrong checksum, cannot continue")
    elif user != buyer:
        __finish_payment(payment, Payment.ERROR, reference)
        raise Exception("Buyer not user, cannot continue")
    elif payment.finished == None:
        __finish_payment(payment, status, reference)
        if status == Payment.SUCCESS:
            BoughtGame.objects.get_or_create(buyer=request.user, game=payment.game)
            return redirect('bought-games')
        else:
            return redirect('games')
    else:
        raise Exception('Payment ' + str(payment.id) + ' was already compleated.')

def __string_to_status(string):
    if string == 'success':
        return Payment.SUCCESS
    elif string == 'cancel':
        return Payment.CANCEL
    elif string == 'error':
        return Payment.ERROR
    else:
        raise ValueError("Unknown status")

def __finish_payment(payment, status, reference):
    payment.status = status
    payment.finished = datetime.now()
    payment.reference = reference
    payment.save()

@login_required
def score(request, pk):
    user = request.user
    bought_game = get_object_or_404(BoughtGame, pk=pk)
    body_unicode = request.body.decode('utf-8')
    body = json.loads(body_unicode)
    Score.objects.create(user=user, game=bought_game.game, score=body['score'])
    return HttpResponse( content_type = "application/json")

WSD_Game_Store/templates/WSD_Game_Store/boughtgame_detail.html
{% extends "base.html" %}

{% block content %}
  <h2>{{boughtgame.game.title}}</h2>
  <iframe id='game-frame' src={{boughtgame.game.url}} width="460" height="380"></iframe>
  <br />
  <h2>Scores</h2>
  <ol>
    {% for score in scores %}
      <li>{{score.user}}: {{score.score}}</li>
    {% endfor %}
  </ol>
{% endblock %}

{% block script %}
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>

  <script>
    window.addEventListener("message", handleMessage, false);

    function handleMessage(message) {
      const data = message.data;
      const csrftoken = getCookie('csrftoken');
      headers = {'X-CSRFToken': csrftoken}
      if(data.messageType === 'SCORE') {
        const postData = {"score": data.score, 'csrfmiddlewaretoken': '{{ csrf_token }}'}
        $.ajax({
          method: "POST",
          url: "{{boughtgame.id}}/score",
          data: JSON.stringify(postData),
          dataType: 'json',
          contentType: 'application/json',
          headers,
        });
      }
    }


    function getCookie(name) {
      var cookieValue = null;
      if (document.cookie && document.cookie !== '') {
          var cookies = document.cookie.split(';');
          for (var i = 0; i < cookies.length; i++) {
              var cookie = cookies[i].trim();
              // Does this cookie string begin with the name we want?
              if (cookie.substring(0, name.length + 1) === (name + '=')) {
                  cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                  break;
              }
          }
      }
      return cookieValue;
    }
  </script>
{% endblock %}

WSD_Game_Store/templates/WSD_Game_Store/boughtgame_list.html
{% extends "base.html" %}

{% block content %}
  <h1>Bought Games</h1>
  <div class='flex-container'>
    {% for bought_game in boughtgame_list %}
      <div class='game-box'>
        <h3 class='game-title'>{{ bought_game.game.title }}</h3>
        <a href='{{ bought_game.id }}'>Play</a>
      </div>
    {% endfor %}
  </div>
{% endblock %}

WSD_Game_Store/templates/WSD_Game_Store/developergame_list.html
{% extends "base.html" %}

{% block content %}
  <h2>Developed Games</h2>
  <a href='create'>Create new game</a>
  <br />
  <ul>
    {% for game in game_list %}
      <li>{{ game.title }}</li>
      <li><a href='{{ game.url }}'>{{ game.url }}</a></li>
      <li>Bought {{game.times_bought}} times</li>
      <li><a href='{{ game.id }}'>Edit</a></li>
      <li><a href='{{ game.id }}/delete'>Delete</a></li>
      <br />
    {% endfor %}
  </ul>
{% endblock %}

WSD_Game_Store/templates/WSD_Game_Store/game_confirm_delete.html
{% extends "base.html" %}

{% block content %}
<form method="post">{% csrf_token %}
    <p>Are you sure you want to delete "{{ game.title }}"?</p>
    <input type="submit" value="Confirm">
    <br />
    <br />
    <a href="/developed-games">Back</a>
</form>
{% endblock %}

WSD_Game_Store/templates/WSD_Game_Store/game_form.html
{% extends "base.html" %}

{% block content %}
  <form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <input type="submit" value="Create Game">
  </form>
{% endblock %}

WSD_Game_Store/templates/WSD_Game_Store/game_list.html
{% extends "base.html" %}

{% block content %}
  <h1>Games</h1>
  <div class='flex-container'>
    {% for game in game_list %}
      <div class='game-box'>
        <h3 class='game-title'>{{ game.title }}</h3>
        By: {{ game.developer }}<br />
        {% if game in bought_games %}
          Already owned!
        {% else %}
          <a href='{{ game.id }}/buy'>Buy for {{ game.price }} €</a>
        {% endif %}
      </div>
    {% endfor %}
  <div>
  <br />
{% endblock %}